// CppRestTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

using namespace web::http::experimental::listener;
using namespace web::http;
using namespace web;

class MyListener
{
public:
	MyListener(const http::uri& url);

private:
	void handle_get(http_request request);
	void handle_post(http_request request);
	void handle_options(http_request request);

	void AddCORSHeaders(http_response& response);

	http_listener m_listener;
};

MyListener::MyListener(const http::uri& url) : m_listener(http_listener(url))
{
	m_listener.support(methods::GET, std::tr1::bind(&MyListener::handle_get, this, std::tr1::placeholders::_1));
	m_listener.support(methods::POST, std::tr1::bind(&MyListener::handle_post, this, std::tr1::placeholders::_1));
	m_listener.support(methods::OPTIONS, std::tr1::bind(&MyListener::handle_options, this, std::tr1::placeholders::_1));

	m_listener.open().wait();
}

void MyListener::handle_get(http_request message)
{
	http_response response(status_codes::OK);
	AddCORSHeaders(response);
	message.reply(response);
};

void MyListener::handle_post(http_request message)
{
	http_response response(status_codes::OK);
	AddCORSHeaders(response);
	message.reply(response);
};

void MyListener::handle_options(http_request message)
{
	http_response response(status_codes::OK);
	response.headers().add(U("Allow"), U("GET, POST, PUT, DELETE, OPTIONS"));
	AddCORSHeaders(response);
	message.reply(response);
}

void MyListener::AddCORSHeaders(http_response& response)
{
	response.headers().add(U("Access-Control-Allow-Origin"), U("*"));
	response.headers().add(U("Access-Control-Allow-Methods"), U("POST,GET,PUT,DELETE,OPTIONS"));
	response.headers().add(U("Access-Control-Allow-Headers"), U("X-Requested-With,Content-Type,accept"));
}

int _tmain(int argc, _TCHAR* argv[])
{
	MyListener* listen = new MyListener(*(new uri(L"https://127.0.0.1:23024")));
	
	int test;
	std::cin >> test;

	return 0;
}

